import { Column, Entity, Index, JoinColumn, ManyToOne } from 'typeorm';
import { AbstractEntity } from '../../abstract/entities/abstract.entity';
import { UserEntity } from '../../user/entities/user.entity';
import { VisitorPasswordDto } from '../dtos';

@Entity({ name: 'visitor-password' })
@Index('IDX_PASSWORD_TUYA_UUID', ['passwordTuyaUuid'])
export class VisitorPasswordEntity extends AbstractEntity<VisitorPasswordDto> {
  @Column({
    nullable: false,
    unique: true,
  })
  public passwordTuyaUuid: string;

  @ManyToOne(() => UserEntity, (user) => user.visitorPasswords, {
    nullable: false,
    onDelete: 'CASCADE',
  })
  @JoinColumn({ name: 'authorizer_uuid' })
  public user: UserEntity;

  constructor(partial: Partial<VisitorPasswordEntity>) {
    super();
    Object.assign(this, partial);
  }
}
