import { Global, Module } from '@nestjs/common';
import { SeederService } from './services/seeder.service';
import { PermissionTypeRepository } from '../modules/permission/repositories';
import { PermissionTypeSeeder } from './services/permission.type.seeder';
import { PermissionTypeRepositoryModule } from '../modules/permission/permission.repository.module';
import { ConfigModule } from '@nestjs/config';
import { RoleTypeRepositoryModule } from '../modules/role-type/role.type.repository.module';
import { RoleTypeRepository } from '../modules/role-type/repositories';
import { RoleTypeSeeder } from './services/role.type.seeder';
import { SpaceRepositoryModule } from '../modules/space/space.repository.module';
import { SuperAdminSeeder } from './services/supper.admin.seeder';
import { UserRepository } from '../modules/user/repositories';
import { UserRepositoryModule } from '../modules/user/user.repository.module';
import { RegionSeeder } from './services/regions.seeder';
import { RegionRepository } from '../modules/region/repositories';
import { TimeZoneSeeder } from './services/timezone.seeder';
import { TimeZoneRepository } from '../modules/timezone/repositories';
import { SceneIconSeeder } from './services/scene.icon.seeder';
import { SceneIconRepository } from '../modules/scene/repositories';
@Global()
@Module({
  providers: [
    PermissionTypeSeeder,
    RoleTypeSeeder,
    SeederService,
    PermissionTypeRepository,
    RoleTypeRepository,
    SuperAdminSeeder,
    UserRepository,
    RegionSeeder,
    RegionRepository,
    TimeZoneSeeder,
    TimeZoneRepository,
    SceneIconSeeder,
    SceneIconRepository,
  ],
  exports: [SeederService],
  controllers: [],
  imports: [
    ConfigModule.forRoot(),
    PermissionTypeRepositoryModule,
    RoleTypeRepositoryModule,
    UserRepositoryModule,
    SpaceRepositoryModule,
  ],
})
export class SeederModule {}
