WITH params AS (
  SELECT 
    $1::uuid AS space_uuid,
    TO_DATE(NULLIF($2, ''), 'YYYY-MM') AS event_month
)

SELECT 
  sdp.space_uuid,
  sdp.event_date,
  sdp.good_aqi_percentage, sdp.moderate_aqi_percentage, sdp.unhealthy_sensitive_aqi_percentage, sdp.unhealthy_aqi_percentage, 
  sdp.very_unhealthy_aqi_percentage, sdp.hazardous_aqi_percentage,
  sdp.daily_avg_aqi, sdp.daily_max_aqi, sdp.daily_min_aqi,

  sdp.good_pm25_percentage, sdp.moderate_pm25_percentage, sdp.unhealthy_sensitive_pm25_percentage, sdp.unhealthy_pm25_percentage, 
  sdp.very_unhealthy_pm25_percentage, sdp.hazardous_pm25_percentage,
  sdp.daily_avg_pm25, sdp.daily_max_pm25, sdp.daily_min_pm25,

  sdp.good_pm10_percentage, sdp.moderate_pm10_percentage, sdp.unhealthy_sensitive_pm10_percentage, sdp.unhealthy_pm10_percentage, 
  sdp.very_unhealthy_pm10_percentage, sdp.hazardous_pm10_percentage,
  sdp.daily_avg_pm10, sdp.daily_max_pm10, sdp.daily_min_pm10,

  sdp.good_voc_percentage, sdp.moderate_voc_percentage, sdp.unhealthy_sensitive_voc_percentage, sdp.unhealthy_voc_percentage, 
  sdp.very_unhealthy_voc_percentage, sdp.hazardous_voc_percentage,
  sdp.daily_avg_voc, sdp.daily_max_voc, sdp.daily_min_voc,

  sdp.good_co2_percentage, sdp.moderate_co2_percentage, sdp.unhealthy_sensitive_co2_percentage, sdp.unhealthy_co2_percentage, 
  sdp.very_unhealthy_co2_percentage, sdp.hazardous_co2_percentage,
  sdp.daily_avg_co2, sdp.daily_max_co2, sdp.daily_min_co2,

  sdp.good_ch2o_percentage, sdp.moderate_ch2o_percentage, sdp.unhealthy_sensitive_ch2o_percentage, sdp.unhealthy_ch2o_percentage, 
  sdp.very_unhealthy_ch2o_percentage, sdp.hazardous_ch2o_percentage,
  sdp.daily_avg_ch2o, sdp.daily_max_ch2o, sdp.daily_min_ch2o

FROM public."space-daily-pollutant-stats" AS sdp
CROSS JOIN params p
WHERE 
  (p.space_uuid IS NULL OR sdp.space_uuid = p.space_uuid)
  AND (p.event_month IS NULL OR TO_CHAR(sdp.event_date, 'YYYY-MM') = TO_CHAR(p.event_month, 'YYYY-MM'))
ORDER BY sdp.space_uuid, sdp.event_date;