-- will return the presence metrics for the days of the selected month 
WITH params AS (
	SELECT 
      TO_DATE(NULLIF($2, ''), 'YYYY-MM') AS month,
      string_to_array(NULLIF($4, ''), ',') AS device_ids
)

	SELECT 
      A.device_uuid,
      A.event_date,
      A.count_motion_detected,
      A.count_presence_detected,
      A.count_total_presence_detected
	FROM public."presence-sensor-daily-device-detection" AS A
	JOIN params P ON TRUE
	WHERE A.device_uuid::text = ANY(P.device_ids)
	  AND (P.month IS NULL 
	    OR date_trunc('month', A.event_date) = P.month
	  );
	  