type TypeORMSortQuery = { [key: string]: 'ASC' | 'DESC' };

export function buildTypeORMSortQuery(
  sortParam: string | undefined,
): TypeORMSortQuery {
  // sortParam format: userId:asc,createdDate:desc
  if (!sortParam) {
    return {};
  }

  const conditions: string[] = sortParam.split(',');

  return conditions.reduce((acc: TypeORMSortQuery, condition) => {
    const [field, direction] = condition.split(':').map((str) => str.trim());
    acc[field] = direction.toUpperCase() === 'DESC' ? 'DESC' : 'ASC';
    return acc;
  }, {});
}
