import { PageResponseDto } from '../dto/pagination.response.dto';

export function getPaginationResponseDto(
  count: number,
  page: number,
  size: number,
): PageResponseDto {
  const totalItem = count;
  const totalPage = Math.ceil(totalItem / size);
  const hasNext = page < totalPage ? true : false;
  const hasPrevious = page === 1 || page > totalPage ? false : true;

  return {
    hasNext,
    hasPrevious,
    page,
    size,
    totalItem,
    totalPage,
  };
}
