import { Module } from '@nestjs/common';
import { DoorLockService } from './services/door.lock.service';
import { DoorLockController } from './controllers/door.lock.controller';
import { ConfigModule } from '@nestjs/config';
import { DeviceRepositoryModule } from '@app/common/modules/device';
import { DeviceRepository } from '@app/common/modules/device/repositories';
import { PasswordEncryptionService } from './services/encryption.services';
import { VisitorPasswordRepository } from '@app/common/modules/visitor-password/repositories';
import { DeviceService } from 'src/device/services';
import { ProductRepository } from '@app/common/modules/product/repositories';
import { DeviceStatusFirebaseService } from '@app/common/firebase/devices-status/services/devices-status.service';
import { SpaceRepository } from '@app/common/modules/space/repositories';
import { DeviceStatusLogRepository } from '@app/common/modules/device-status-log/repositories';
import { TuyaService } from '@app/common/integrations/tuya/services/tuya.service';
import { SceneService } from 'src/scene/services';
import {
  SceneIconRepository,
  SceneRepository,
} from '@app/common/modules/scene/repositories';
import { SceneDeviceRepository } from '@app/common/modules/scene-device/repositories';
import { AutomationRepository } from '@app/common/modules/automation/repositories';
import { ProjectRepository } from '@app/common/modules/project/repositiories';
import { PowerClampService } from '@app/common/helper/services/power.clamp.service';
import {
  PowerClampHourlyRepository,
  PowerClampDailyRepository,
  PowerClampMonthlyRepository,
} from '@app/common/modules/power-clamp/repositories';
import { SqlLoaderService } from '@app/common/helper/services/sql-loader.service';
import { OccupancyService } from '@app/common/helper/services/occupancy.service';
import { CommunityRepository } from '@app/common/modules/community/repositories';
import { AqiDataService } from '@app/common/helper/services/aqi.data.service';
@Module({
  imports: [ConfigModule, DeviceRepositoryModule],
  controllers: [DoorLockController],
  providers: [
    DoorLockService,
    PasswordEncryptionService,
    DeviceRepository,
    VisitorPasswordRepository,
    DeviceService,
    ProductRepository,
    DeviceStatusFirebaseService,
    SpaceRepository,
    DeviceStatusLogRepository,
    ProjectRepository,
    TuyaService,
    SceneService,
    SceneIconRepository,
    SceneRepository,
    SceneDeviceRepository,
    AutomationRepository,
    PowerClampService,
    PowerClampHourlyRepository,
    PowerClampDailyRepository,
    PowerClampMonthlyRepository,
    SqlLoaderService,
    OccupancyService,
    CommunityRepository,
    AqiDataService,
  ],
  exports: [DoorLockService],
})
export class DoorLockModule {}
