import { DeviceRepositoryModule } from '@app/common/modules/device';
import { DeviceRepository } from '@app/common/modules/device/repositories';
import { Module } from '@nestjs/common';
import { ConfigModule } from '@nestjs/config';
import { RoleService } from './services/role.service';
import { RoleController } from './controllers/role.controller';
import { DeviceUserPermissionRepository } from '@app/common/modules/device/repositories';
import { PermissionTypeRepository } from '@app/common/modules/permission/repositories';
import { RoleTypeRepository } from '@app/common/modules/role-type/repositories';

@Module({
  imports: [ConfigModule, DeviceRepositoryModule],
  controllers: [RoleController],
  providers: [
    DeviceUserPermissionRepository,
    PermissionTypeRepository,
    DeviceRepository,
    RoleService,
    RoleTypeRepository,
  ],
  exports: [RoleService],
})
export class RoleModule {}
