import { Module } from '@nestjs/common';
import { ScheduleService } from './services/schedule.service';
import { ScheduleController } from './controllers/schedule.controller';
import { ConfigModule } from '@nestjs/config';
import { DeviceRepositoryModule } from '@app/common/modules/device';
import { DeviceRepository } from '@app/common/modules/device/repositories';
@Module({
  imports: [ConfigModule, DeviceRepositoryModule],
  controllers: [ScheduleController],
  providers: [ScheduleService, DeviceRepository],
  exports: [ScheduleService],
})
export class ScheduleModule {}
