import { HttpException, HttpStatus, Injectable } from '@nestjs/common';
import { In, QueryRunner } from 'typeorm';

import { ProductEntity } from '@app/common/modules/product/entities';
import { ProjectEntity } from '@app/common/modules/project/entities';
import { SpaceRepository } from '@app/common/modules/space';
import {
  SpaceModelEntity,
  SpaceModelProductAllocationEntity,
  SpaceModelProductAllocationRepoitory,
} from '@app/common/modules/space-model';
import { NewTagEntity } from '@app/common/modules/tag';
import { ModifyTagDto } from 'src/space/dtos/tag/modify-tag.dto';
import { ProcessTagDto } from 'src/tags/dtos';
import { TagService as NewTagService } from 'src/tags/services';
import { ModifySubspaceModelDto } from '../dtos';
import { IUpdatedSpaceAllocations } from '../interfaces';

@Injectable()
export class SpaceModelProductAllocationService {
  constructor(
    private readonly tagService: NewTagService,
    private readonly spaceModelProductAllocationRepository: SpaceModelProductAllocationRepoitory,
    private readonly spaceRepository: SpaceRepository,
  ) {}

  async createProductAllocations(
    projectUuid: string,
    spaceModel: SpaceModelEntity,
    tags: ProcessTagDto[],
    queryRunner?: QueryRunner,
    modifySubspaceModels?: ModifySubspaceModelDto[],
  ): Promise<IUpdatedSpaceAllocations[]> {
    // try {
    if (!tags.length) return [];

    const allocationUpdates: IUpdatedSpaceAllocations[] = [];
    return allocationUpdates;
    //   const processedTags = await this.tagService.processTags(
    //     tags,
    //     projectUuid,
    //     queryRunner,
    //   );

    //   const productAllocations: SpaceModelProductAllocationEntity[] = [];
    //   const existingAllocations = new Map<
    //     string,
    //     SpaceModelProductAllocationEntity
    //   >();

    //   for (const tag of processedTags) {
    //     let isTagNeeded = true;

    //     if (modifySubspaceModels) {
    //       const relatedSubspaces = await queryRunner.manager.find(
    //         SubspaceModelProductAllocationEntity,
    //         {
    //           where: {
    //             product: { uuid: tag.product.uuid },
    //             subspaceModel: { spaceModel: { uuid: spaceModel.uuid } },
    //             tags: { uuid: tag.uuid },
    //           },
    //           relations: ['subspaceModel', 'tags'],
    //         },
    //       );

    //       for (const subspaceWithTag of relatedSubspaces) {
    //         const modifyingSubspace = modifySubspaceModels.find(
    //           (subspace) =>
    //             subspace.action === ModifyAction.UPDATE &&
    //             subspace.uuid === subspaceWithTag.subspaceModel.uuid,
    //         );

    //         if (
    //           modifyingSubspace &&
    //           modifyingSubspace.tags &&
    //           modifyingSubspace.tags.some(
    //             (subspaceTag) =>
    //               subspaceTag.action === ModifyAction.DELETE &&
    //               subspaceTag.tagUuid === tag.uuid,
    //           )
    //         ) {
    //           isTagNeeded = true;
    //           break;
    //         }
    //       }
    //     }

    //     if (isTagNeeded) {
    //       const hasTags = await this.validateTagWithinSpaceModel(
    //         queryRunner,
    //         tag,
    //         spaceModel,
    //       );

    //       if (hasTags) continue;

    //       let allocation = existingAllocations.get(tag.product.uuid);
    //       if (!allocation) {
    //         allocation = await this.getAllocationByProduct(
    //           tag.product,
    //           spaceModel,
    //           queryRunner,
    //         );
    //         if (allocation) {
    //           existingAllocations.set(tag.product.uuid, allocation);
    //         }
    //       }

    //       if (!allocation) {
    //         allocation = this.createNewAllocation(spaceModel, tag, queryRunner);
    //         productAllocations.push(allocation);
    //         allocationUpdates.push({
    //           newAllocation: allocation,
    //         });
    //       } else if (!allocation.tags.some((t) => t.uuid === tag.uuid)) {
    //         allocation.tags.push(tag);
    //         allocationUpdates.push({
    //           allocation: allocation,
    //           tagsAdded: [tag],
    //         });
    //         await this.saveAllocation(allocation, queryRunner);
    //       }
    //     }
    //   }

    //   if (productAllocations.length > 0) {
    //     await this.saveAllocations(productAllocations, queryRunner);
    //   }

    //   return allocationUpdates;
    // } catch (error) {
    //   throw this.handleError(error, 'Failed to create product allocations');
    // }
  }

  async updateProductAllocations(
    dtos: ModifyTagDto[],
    project: ProjectEntity,
    spaceModel: SpaceModelEntity,
    queryRunner: QueryRunner,
    modifySubspaceModels?: ModifySubspaceModelDto[],
  ): Promise<IUpdatedSpaceAllocations[]> {
    const allocationUpdates: IUpdatedSpaceAllocations[] = [];
    return allocationUpdates;
    // try {
    //   const addDtos = dtos.filter((dto) => dto.action === ModifyAction.ADD);
    //   const deleteDtos = dtos.filter(
    //     (dto) => dto.action === ModifyAction.DELETE,
    //   );
    //   const addTagDtos: ProcessTagDto[] = addDtos.map((dto) => ({
    //     name: dto.name,
    //     productUuid: dto.productUuid,
    //     uuid: dto.newTagUuid,
    //   }));
    //   // Process added tags
    //   const processedTags = await this.tagService.processTags(
    //     addTagDtos,
    //     project.uuid,
    //     queryRunner,
    //   );
    //   const addTagUuidMap = new Map<string, ModifyTagModelDto>();
    //   processedTags.forEach((tag, index) => {
    //     addTagUuidMap.set(tag.uuid, addDtos[index]);
    //   });
    //   const addTagUuids = new Set(processedTags.map((tag) => tag.uuid));
    //   const deleteTagUuids = new Set(deleteDtos.map((dto) => dto.tagUuid));
    //   const tagsToIgnore = new Set(
    //     [...addTagUuids].filter((uuid) => deleteTagUuids.has(uuid)),
    //   );
    //   // Filter out tags that are added and deleted in the same request
    //   const filteredDtos = dtos.filter(
    //     (dto) =>
    //       !(
    //         tagsToIgnore.has(dto.tagUuid) ||
    //         (dto.action === ModifyAction.ADD &&
    //           tagsToIgnore.has(
    //             [...addTagUuidMap.keys()].find(
    //               (uuid) => addTagUuidMap.get(uuid) === dto,
    //             ),
    //           ))
    //       ),
    //   );
    //   // Process add and delete actions concurrently
    //   const [updatedAllocations, deletedAllocations] = await Promise.all([
    //     this.processAddActions(
    //       filteredDtos,
    //       project.uuid,
    //       spaceModel,
    //       queryRunner,
    //       modifySubspaceModels,
    //     ),
    //     this.processDeleteActions(filteredDtos, queryRunner, spaceModel),
    //   ]);
    //   // Combine results and return
    //   return [...updatedAllocations, ...deletedAllocations];
    // } catch (error) {
    //   throw this.handleError(error, 'Error while updating product allocations');
    // }
  }

  private async processAddActions(
    dtos: ModifyTagDto[],
    projectUuid: string,
    spaceModel: SpaceModelEntity,
    queryRunner: QueryRunner,
    modifySubspaceModels?: ModifySubspaceModelDto[],
  ): Promise<IUpdatedSpaceAllocations[]> {
    const allocationUpdates: IUpdatedSpaceAllocations[] = [];
    return allocationUpdates;
    // const addDtos: ProcessTagDto[] = dtos
    //   .filter((dto) => dto.action === ModifyAction.ADD)
    //   .map((dto) => ({
    //     name: dto.name,
    //     productUuid: dto.productUuid,
    //     uuid: dto.newTagUuid,
    //   }));

    // if (addDtos.length > 0) {
    //   allocationUpdates = await this.createProductAllocations(
    //     projectUuid,
    //     spaceModel,
    //     addDtos,
    //     queryRunner,
    //     modifySubspaceModels,
    //   );
    // }
    // return allocationUpdates;
  }

  private createNewAllocation(
    spaceModel: SpaceModelEntity,
    tag: NewTagEntity,
    queryRunner?: QueryRunner,
  ) {
    // : SpaceModelProductAllocationEntity
    // return queryRunner
    //   ? queryRunner.manager.create(SpaceModelProductAllocationEntity, {
    //       spaceModel,
    //       product: tag.product,
    //       tags: [tag],
    //     })
    //   : this.spaceModelProductAllocationRepository.create({
    //       spaceModel,
    //       product: tag.product,
    //       tags: [tag],
    //     });
  }

  private async getAllocationByProduct(
    product: ProductEntity,
    spaceModel: SpaceModelEntity,
    queryRunner?: QueryRunner,
  ): Promise<SpaceModelProductAllocationEntity | null> {
    return queryRunner
      ? queryRunner.manager.findOne(SpaceModelProductAllocationEntity, {
          where: {
            spaceModel: { uuid: spaceModel.uuid },
            product: { uuid: product.uuid },
          },
          relations: ['tags'],
        })
      : this.spaceModelProductAllocationRepository.findOne({
          where: {
            spaceModel: { uuid: spaceModel.uuid },
            product: { uuid: product.uuid },
          },
          relations: ['tags'],
        });
  }

  private async saveAllocation(
    allocation: SpaceModelProductAllocationEntity,
    queryRunner?: QueryRunner,
  ) {
    queryRunner
      ? await queryRunner.manager.save(
          SpaceModelProductAllocationEntity,
          allocation,
        )
      : await this.spaceModelProductAllocationRepository.save(allocation);
  }

  private async saveAllocations(
    allocations: SpaceModelProductAllocationEntity[],
    queryRunner?: QueryRunner,
  ) {
    queryRunner
      ? await queryRunner.manager.save(
          SpaceModelProductAllocationEntity,
          allocations,
        )
      : await this.spaceModelProductAllocationRepository.save(allocations);
  }

  private handleError(error: any, message: string): HttpException {
    return new HttpException(
      error instanceof HttpException ? error.message : message,
      error instanceof HttpException
        ? error.getStatus()
        : HttpStatus.INTERNAL_SERVER_ERROR,
    );
  }

  private async processDeleteActions(
    dtos: ModifyTagDto[],
    queryRunner: QueryRunner,
    spaceModel: SpaceModelEntity,
  ): Promise<IUpdatedSpaceAllocations[]> {
    try {
      if (!dtos || dtos.length === 0) {
        return;
      }
      const allocationUpdateToPropagate: IUpdatedSpaceAllocations[] = [];

      const tagUuidsToDelete = dtos
        // .filter((dto) => dto.action === ModifyAction.DELETE && dto.tagUuid)
        .map((dto) => dto.tagUuid);

      if (tagUuidsToDelete.length === 0) return [];

      const allocationsToUpdate = await queryRunner.manager.find(
        SpaceModelProductAllocationEntity,
        {
          where: {
            tag: In(tagUuidsToDelete),
            spaceModel: {
              uuid: spaceModel.uuid,
            },
          },
          relations: [
            'tags',
            'inheritedSpaceAllocations',
            'inheritedSpaceAllocations.tags',
          ],
        },
      );

      if (!allocationsToUpdate || allocationsToUpdate.length === 0) return [];

      const deletedAllocations: SpaceModelProductAllocationEntity[] = [];
      const allocationUpdates: SpaceModelProductAllocationEntity[] = [];

      for (const allocation of allocationsToUpdate) {
        // const updatedTags = allocation.tags.filter(
        //   (tag) => !tagUuidsToDelete.includes(tag.uuid),
        // );
        // const deletedTags = allocation.tags.filter((tag) =>
        //   tagUuidsToDelete.includes(tag.uuid),
        // );
        // if (updatedTags.length === allocation.tags.length) {
        //   continue;
        // }
        // if (updatedTags.length === 0) {
        //   deletedAllocations.push(allocation);
        //   allocationUpdateToPropagate.push({
        //     deletedAllocation: allocation,
        //   });
        // } else {
        //   allocation.tags = updatedTags;
        //   allocationUpdates.push(allocation);
        //   allocationUpdateToPropagate.push({
        //     allocation: allocation,
        //     tagsRemoved: deletedTags,
        //   });
        // }
      }

      if (allocationUpdates.length > 0) {
        await queryRunner.manager.save(
          SpaceModelProductAllocationEntity,
          allocationUpdates,
        );
      }

      if (deletedAllocations.length > 0) {
        await queryRunner.manager.remove(
          SpaceModelProductAllocationEntity,
          deletedAllocations,
        );
      }

      await queryRunner.manager
        .createQueryBuilder()
        .delete()
        .from('space_model_product_tags')
        .where(
          'space_model_product_allocation_uuid NOT IN (' +
            queryRunner.manager
              .createQueryBuilder()
              .select('allocation.uuid')
              .from(SpaceModelProductAllocationEntity, 'allocation')
              .getQuery() +
            ')',
        )
        .execute();

      return allocationUpdateToPropagate;
    } catch (error) {
      throw this.handleError(error, `Failed to delete tags in space model`);
    }
  }

  private async validateTagWithinSpaceModel(
    queryRunner: QueryRunner,
    tag: NewTagEntity,
    spaceModel: SpaceModelEntity,
  ): Promise<boolean> {
    return true;
    // const existingAllocationsForProduct = await queryRunner.manager.find(
    //   SpaceModelProductAllocationEntity,
    //   {
    //     where: {
    //       spaceModel: {
    //         uuid: spaceModel.uuid,
    //       },
    //       product: {
    //         uuid: tag.product.uuid,
    //       },
    //     },
    //     relations: ['tags'],
    //   },
    // );

    // const existingTagsForProduct = existingAllocationsForProduct.flatMap(
    //   (allocation) => allocation.tags,
    // );

    // const isDuplicateTag = existingTagsForProduct.some(
    //   (existingTag) => existingTag.uuid === tag.uuid,
    // );

    // if (isDuplicateTag) {
    //   return true;
    // }
    // return false;
  }

  async clearAllAllocations(spaceModelUuid: string, queryRunner: QueryRunner) {
    try {
      await queryRunner.manager
        .createQueryBuilder()
        .delete()
        .from(SpaceModelProductAllocationEntity)
        .where('space_model_uuid = :spaceModelUuid', { spaceModelUuid })
        .execute();
    } catch (error) {
      throw this.handleError(
        error,
        `Failed to clear all allocations in the space model product allocation`,
      );
    }
  }
}
