import { ApiProperty } from '@nestjs/swagger';
import { IsNotEmpty, IsString } from 'class-validator';

export class UpdateSubspaceDto {
  @ApiProperty({
    description: 'Name of the subspace',
    example: 'Living Room',
  })
  @IsNotEmpty()
  @IsString()
  subspaceName?: string;

  @IsNotEmpty()
  @IsString()
  subspaceUuid: string;
}
