import { Module } from '@nestjs/common';
import { ConfigModule } from '@nestjs/config';
import { TagController } from './controllers';
import { TagService } from './services';
import { NewTagRepository } from '@app/common/modules/tag/repositories/tag-repository';
import { ProductRepository } from '@app/common/modules/product/repositories';
import { ProjectRepository } from '@app/common/modules/project/repositiories';

@Module({
  imports: [ConfigModule],
  controllers: [TagController],
  providers: [
    TagService,
    NewTagRepository,
    ProductRepository,
    ProjectRepository,
  ],
  exports: [TagService],
})
export class TagModule {}
