import { ApiProperty } from '@nestjs/swagger';
import { IsUUID } from 'class-validator';
import { UserParamDto } from './user-param.dto';

export class UserCommunityParamDto extends UserParamDto {
  @ApiProperty({
    description: 'UUID of the community',
    example: 'a9b2c7f5-4d6e-423d-a24d-6f9c758b1b92',
  })
  @IsUUID()
  communityUuid: string;
}
