import { WorkingDays } from '@app/common/constants/working-days';

export interface createTickInterface {
  success: boolean;
  result: {
    expire_time: number;
    ticket_id: string;
    ticket_key: string;
    id?: number;
    offline_temp_password_id?: string;
    offline_temp_password?: string;
  };
  msg?: string;
}
export interface addDeviceObjectInterface {
  passwordName: string;
  encryptedPassword: string;
  effectiveTime: string;
  invalidTime: string;
  ticketId: string;
  scheduleList?: any[];
}

export interface ScheduleDto {
  effectiveTime: string;
  invalidTime: string;
  workingDay: WorkingDays[];
}

export interface AddDoorLockOnlineInterface {
  passwordName: string;
  password: string;
  effectiveTime: string;
  invalidTime: string;
  scheduleList?: ScheduleDto[];
}
export interface getPasswordInterface {
  success: boolean;
  result: [
    {
      effective_time: number;
      id: number;
      invalid_time: number;
      passwordName: string;
      phase: number;
      phone: string;
      schedule_list?: [];
      sn: number;
      time_zone: string;
      type: number;
    },
  ];
  msg?: string;
}
export interface deleteTemporaryPasswordInterface {
  success: boolean;
  result: boolean;
  msg?: string;
}
export interface getPasswordOfflineInterface {
  success: boolean;
  result: {
    records: [];
  };
  msg?: string;
}
